qlserver 4.1 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159
  1. #!/bin/bash
  2. # Quake Live
  3. # Server Management Script
  4. # Author: Daniel Gibbs
  5. # Website: https://gameservermanagers.com
  6. if [ -f ".dev-debug" ]; then
  7. exec 5>dev-debug.log
  8. BASH_XTRACEFD="5"
  9. set -x
  10. fi
  11. version="060516"
  12. #### Variables ####
  13. # Notification Alerts
  14. # (on|off)
  15. # Email
  16. emailalert="off"
  17. email="email@example.com"
  18. # Pushbullet
  19. # https://www.pushbullet.com/#settings
  20. pushbulletalert="off"
  21. pushbullettoken="accesstoken"
  22. # Steam login
  23. steamuser="anonymous"
  24. steampass=""
  25. # Start Variables
  26. arch="x64" # x64 or x86
  27. port="27960"
  28. rconport="28960"
  29. rconpassword="CHANGE_ME"
  30. statsport="${port}"
  31. statspassword="CHANGE_ME"
  32. mappool='mappool.txt'
  33. ip="0.0.0.0"
  34. updateonstart="off"
  35. # Install/Config Guide : https://steamcommunity.com/sharedfiles/filedetails/?id=542966946
  36. # Console Commands : http://www.regurge.at/ql/
  37. fn_parms(){
  38. parms="+set net_strict 1 +set net_ip ${ip} +set net_port ${port} +set fs_homepath ${filesdir}/${port} +set zmq_rcon_enable 1 +set zmq_rcon_port ${rconport} +set zmq_rcon_password ${rconpassword} +set zmq_stats_enable 1 +set zmq_stats_password ${statspassword} +set zmq_stats_port ${statsport} +set sv_mapPoolFile ${mappool} +exec ${servercfg}"
  39. }
  40. #### Advanced Variables ####
  41. # Github Branch Select
  42. # Allows for the use of different function files
  43. # from a different repo and/or branch.
  44. githubuser="dgibbs64"
  45. githubrepo="linuxgsm"
  46. githubbranch="master"
  47. # Steam
  48. appid="349090"
  49. # Server Details
  50. servicename="ql-server"
  51. gamename="Quake Live"
  52. engine="idtech3"
  53. # Directories
  54. rootdir="$(dirname $(readlink -f "${BASH_SOURCE[0]}"))"
  55. selfname="$(basename $(readlink -f "${BASH_SOURCE[0]}"))"
  56. lockselfname=".${servicename}.lock"
  57. lgsmdir="${rootdir}/lgsm"
  58. functionsdir="${lgsmdir}/functions"
  59. filesdir="${rootdir}/serverfiles"
  60. systemdir="${filesdir}"
  61. executabledir="${filesdir}"
  62. executable=$([ "${arch}" == 'x64' ] && echo "./run_server_x64.sh" || echo "./run_server_x86.sh")
  63. servercfg="${servicename}.cfg"
  64. servercfgdir="${filesdir}/baseq3"
  65. servercfgfullpath="${servercfgdir}/${servercfg}"
  66. servercfgdefault="${servercfgdir}/lgsm-default.cfg"
  67. backupdir="${rootdir}/backups"
  68. # Logging
  69. logdays="7"
  70. gamelogdir="${rootdir}/log/server"
  71. scriptlogdir="${rootdir}/log/script"
  72. consolelogdir="${rootdir}/log/console"
  73. consolelogging="on"
  74. gamelog="${gamelogdir}/${servicename}-game.log"
  75. scriptlog="${scriptlogdir}/${servicename}-script.log"
  76. consolelog="${consolelogdir}/${servicename}-console.log"
  77. emaillog="${scriptlogdir}/${servicename}-email.log"
  78. scriptlogdate="${scriptlogdir}/${servicename}-script-$(date '+%d-%m-%Y-%H-%M-%S').log"
  79. consolelogdate="${consolelogdir}/${servicename}-console-$(date '+%d-%m-%Y-%H-%M-%S').log"
  80. ##### Script #####
  81. # Do not edit
  82. # Fetches core_dl for file downloads
  83. fn_fetch_core_dl(){
  84. github_file_url_dir="lgsm/functions"
  85. github_file_url_name="${functionfile}"
  86. filedir="${functionsdir}"
  87. filename="${github_file_url_name}"
  88. githuburl="https://raw.githubusercontent.com/${githubuser}/${githubrepo}/${githubbranch}/${github_file_url_dir}/${github_file_url_name}"
  89. # If the file is missing, then download
  90. if [ ! -f "${filedir}/${filename}" ]; then
  91. if [ ! -d "${filedir}" ]; then
  92. mkdir -p "${filedir}"
  93. fi
  94. echo -e " fetching ${filename}...\c"
  95. # Check curl exists and use available path
  96. curlpaths="$(command -v curl 2>/dev/null) $(which curl >/dev/null 2>&1) /usr/bin/curl /bin/curl /usr/sbin/curl /sbin/curl)"
  97. for curlcmd in ${curlpaths}
  98. do
  99. if [ -x "${curlcmd}" ]; then
  100. break
  101. fi
  102. done
  103. # If curl exists download file
  104. if [ "$(basename ${curlcmd})" == "curl" ]; then
  105. curlfetch=$(${curlcmd} -s --fail -o "${filedir}/${filename}" "${githuburl}" 2>&1)
  106. if [ $? -ne 0 ]; then
  107. echo -e "\e[0;31mFAIL\e[0m\n"
  108. echo "${curlfetch}"
  109. echo -e "${githuburl}\n"
  110. exit 1
  111. else
  112. echo -e "\e[0;32mOK\e[0m"
  113. fi
  114. else
  115. echo -e "\e[0;31mFAIL\e[0m\n"
  116. echo "Curl is not installed!"
  117. echo -e ""
  118. exit 1
  119. fi
  120. chmod +x "${filedir}/${filename}"
  121. fi
  122. source "${filedir}/${filename}"
  123. }
  124. core_dl.sh(){
  125. # Functions are defined in core_functions.sh.
  126. functionfile="${FUNCNAME}"
  127. fn_fetch_core_dl
  128. }
  129. core_functions.sh(){
  130. # Functions are defined in core_functions.sh.
  131. functionfile="${FUNCNAME}"
  132. fn_fetch_core_dl
  133. }
  134. core_dl.sh
  135. core_functions.sh
  136. getopt=$1
  137. core_getopt.sh